#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global automaximize; set automaximize {0}
global che24; set che24 {0}
global ratio; set ratio {100}
global saturation; set saturation {100}
global widget; 
#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global automaximize ; set automaximize {0}
}

init $argc $argv


proc {main} {argc argv} {

}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    wm protocol $base WM_DELETE_WINDOW exit
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 192x195+125+205
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm protocol $base WM_DELETE_WINDOW exit
    wm title $base "Volume Adjustment"
    label $base.lab18 \
        -borderwidth 1 -relief raised -text {Volume adjust / saturate} 
    entry $base.ent19 \
        -textvariable ratio 
    label $base.lab20 \
        -borderwidth 1 -relief raised -text {Amplification ratio in purcent:} 
    button $base.but21 \
        \
        -command {Window hide .top17
Window show .top18
exec ./main [lindex $argv 0] [lindex $argv 1] $automaximize $ratio $saturation [pid] &} \
        -padx 9 -pady 3 -text {Let's jam!} 
    button $base.but22 \
        -command exit -padx 9 -pady 3 -text {Not now.} 
    checkbutton $base.che24 \
        \
        -command {if {$automaximize != 1} {
    set automaximize 1
} else {
    set automaximize 0
}} \
        -text {Auto-maximize volume} -variable che24 
    label $base.lab17 \
        -borderwidth 1 -relief raised -text {Saturation at level in purcent:} 
    entry $base.ent18 \
        -textvariable saturation 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab18 \
        -x 20 -y 10 -anchor nw -bordermode ignore 
    place $base.ent19 \
        -x 5 -y 60 -width 68 -height 22 -anchor nw 
    place $base.lab20 \
        -x 5 -y 40 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 5 -y 165 -anchor nw -bordermode ignore 
    place $base.but22 \
        -x 105 -y 165 -anchor nw -bordermode ignore 
    place $base.che24 \
        -x 5 -y 135 -anchor nw -bordermode ignore 
    place $base.lab17 \
        -x 5 -y 90 -anchor nw -bordermode ignore 
    place $base.ent18 \
        -x 5 -y 110 -width 68 -height 22 -anchor nw -bordermode ignore 
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 142x61+67+144
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Processing"
    wm protocol $base WM_DELETE_WINDOW exit
    label $base.lab19  -borderwidth 1 -relief raised -text {Processing volume...} 
    button $base.but20  -command {exec killall -TERM main
exit} -padx 9 -pady 3 -text Cancel 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab19  -x 5 -y 5 -anchor nw -bordermode ignore 
    place $base.but20  -x 70 -y 30 -anchor nw -bordermode ignore
}

Window show .
Window show .top17

main $argc $argv
